#pragma once

#include <UIMLView.h>
#include <Either.h>

#include "NetworkAPIProcessor.h"

class InventoryElement : public Framework::UIMLElement
{
public:
	InventoryElement();
	//! prft, ob dieses UIML Element fr ein bestimmtes xml Element zustndig ist
	bool isApplicableFor(Framework::XML::Element& element) override;
	//! erstellt eine neue Zeichnung zu einem gegebenen xml Element
	Framework::Zeichnung* parseElement(Framework::XML::Element& element, Framework::UIMLContainer& generalFactory) override;
	//! wendet die layout parameter zu einer Zeichnung an
	void layout(Framework::XML::Element& element, Framework::Zeichnung& z, int pWidth, int pHeight, Framework::UIMLContainer& generalLayouter) override;
};

struct SlotInfo
{
	int id;
	int itemCount;
	float damage;
	float maxDamage;
	float durability;
	float maxDurability;
	Framework::Bild* zItem;

	void render(int x, int y, Framework::Bild& rObj);
};

class InventoryView : public Framework::ZeichnungHintergrund, public NetworkAPIProcessor
{
private:
	int rowSize;
	// entity id or block position
	Framework::Either<int, Framework::Vec3<int>> target;
	Framework::Text slotNameFilter;
	Framework::Text id;
	Framework::Array<SlotInfo>* slots;

public:
	InventoryView(Framework::Text id, Framework::Either<int, Framework::Vec3<int>> target, int rowSize, Framework::Text slotNameFilter);
	~InventoryView();
	void api(char* message) override;
	bool tick(double tickVal) override;
	void render(Framework::Bild& rObj) override;
	void doMausEreignis(Framework::MausEreignis& me, bool userRet) override;
};
